SystemOrganization addCategory: #'Javascript-Core-Object'!
SystemOrganization addCategory: #'Javascript-Core-Decorations'!
SystemOrganization addCategory: #'Javascript-Core-Parser'!

WAObject subclass: #JSDecoration
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSDecoration commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I decorate JavaScript objects.!

JSDecoration subclass: #JSApply
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSApply commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I apply a JavaScript function and provide arguments.!

!JSApply methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:49'!
arguments
	^ arguments! !

!JSApply methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:49'!
arguments: aCollection
	arguments := aCollection! !

!JSApply methodsFor: 'printing' stamp: 'lr 5/10/2006 21:23'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream arguments: self arguments! !

JSDecoration subclass: #JSAssignment
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssignment commentStamp: 'lr 4/28/2008 09:48' prior: 0!
I represent an assignment ot the decorated object.!

!JSAssignment methodsFor: 'accessing' stamp: 'lr 7/4/2007 07:43'!
object
	^ object! !

!JSAssignment methodsFor: 'accessing' stamp: 'lr 7/4/2007 07:44'!
object: anObject
	object := anObject! !

!JSAssignment methodsFor: 'printing' stamp: 'lr 10/28/2007 14:40'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPutAll: '='; javascript: self object! !

JSDecoration subclass: #JSCreate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCreate commentStamp: 'lr 4/28/2008 09:48' prior: 0!
I instantiate the decorated object.!

!JSCreate methodsFor: 'printing' stamp: 'lr 5/10/2006 08:39'!
printContentOn: aStream
	aStream nextPutAll: 'new '.
	super printContentOn: aStream! !

!JSDecoration methodsFor: 'accessing' stamp: 'lr 11/17/2008 20:16'!
canvas
	^ owner canvas! !

!JSDecoration methodsFor: 'testing' stamp: 'lr 12/4/2008 22:31'!
isJavascript
	^ true! !

!JSDecoration methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:09'!
owner
	^ owner! !

!JSDecoration methodsFor: 'printing' stamp: 'lr 5/9/2006 20:34'!
printContentOn: aStream
	self owner printContentOn: aStream! !

!JSDecoration methodsFor: 'initialization' stamp: 'lr 11/17/2008 20:15'!
setOwner: anObject
	owner := anObject! !

JSDecoration subclass: #JSIfThenElse
	instanceVariableNames: 'trueStatement falseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSIfThenElse commentStamp: 'lr 4/28/2008 09:50' prior: 0!
I execute different code snippets depending if the receiver is true (defined) or false (null).!

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
falseStatement
	^ falseStatement! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
falseStatement: anObject
	falseStatement := anObject! !

!JSIfThenElse methodsFor: 'printing' stamp: 'lr 8/8/2007 14:17'!
printContentOn: aStream
	aStream nextPut: $(.
	super printContentOn: aStream.
	aStream nextPut: $?.
	aStream javascript: self trueStatement.
	aStream nextPut: $:.
	aStream javascript: self falseStatement.
	aStream nextPut: $)! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
trueStatement
	^ trueStatement! !

!JSIfThenElse methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:16'!
trueStatement: anObject
	trueStatement := anObject! !

JSDecoration subclass: #JSMember
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSMember subclass: #JSAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAccess commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I access a member of the decorated object.!

!JSAccess methodsFor: 'printing' stamp: 'lr 5/9/2006 20:48'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPut: $.; nextPutAll: self name! !

JSMember subclass: #JSAlias
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAlias commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I alias the decorated object with a name.!

!JSAlias methodsFor: 'printing' stamp: 'lr 5/18/2006 08:22'!
printContentOn: aStream
	aStream nextPutAll: self name! !

JSMember subclass: #JSAssign
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssign commentStamp: 'lr 4/28/2008 09:51' prior: 0!
I assign the decorated object to a global variable.!

!JSAssign methodsFor: 'printing' stamp: 'lr 7/6/2006 16:27'!
printContentOn: aStream
	aStream nextPutAll: self name; nextPut: $=.
	super printContentOn: aStream! !

JSAssign subclass: #JSAssignLocal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSAssignLocal commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I assign the decorated object to a local variable.!

!JSAssignLocal methodsFor: 'printing' stamp: 'lr 7/6/2006 16:28'!
printContentOn: aStream
	aStream nextPutAll: 'var '.
	super printContentOn: aStream! !

!JSMember class methodsFor: 'instance-creation' stamp: 'lr 10/13/2008 21:42'!
named: anObject
	^ self new name: anObject! !

!JSMember methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:46'!
name
	^ name! !

!JSMember methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:46'!
name: aString
	name := aString! !

JSMember subclass: #JSProperty
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSProperty commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I access a property of the decoarated object.!

!JSProperty methodsFor: 'printing' stamp: 'lr 5/9/2006 20:48'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPut: $[; javascript: self name; nextPut: $]! !

JSDecoration subclass: #JSNegation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSNegation commentStamp: 'lr 4/28/2008 09:52' prior: 0!
I negate the decorated object and yield a boolean value.!

!JSNegation methodsFor: 'printing' stamp: 'lr 1/4/2007 17:37'!
printContentOn: aStream
	aStream nextPut: $!!.
	super printContentOn: aStream! !

JSDecoration subclass: #JSStatement
	instanceVariableNames: 'statement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSStatement subclass: #JSBinary
	instanceVariableNames: 'operator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSBinary commentStamp: 'lr 4/28/2008 09:54' prior: 0!
I join the decorated object with a binary operator.!

!JSBinary methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:22'!
operator
	^ operator! !

!JSBinary methodsFor: 'accessing' stamp: 'lr 7/10/2007 10:22'!
operator: aString
	operator := aString! !

!JSBinary methodsFor: 'printing' stamp: 'lr 7/10/2007 10:23'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPutAll: self operator; javascript: self statement! !

JSStatement subclass: #JSConcate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSConcate methodsFor: 'printing' stamp: 'lr 10/14/2008 12:20'!
printContentOn: aStream
	super printContentOn: aStream.
	aStream nextPut: $;; javascript: self statement! !

JSStatement subclass: #JSCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSCondition commentStamp: 'lr 4/28/2008 09:53' prior: 0!
I wrap the decorated object into a conditional statement.!

!JSCondition methodsFor: 'printing' stamp: 'lr 5/9/2006 20:29'!
printContentOn: aStream
	aStream nextPutAll: 'if('; javascript: self statement; nextPutAll: '){'.
	super printContentOn: aStream.
	aStream nextPut: $}! !

!JSStatement class methodsFor: 'instance-creation' stamp: 'lr 5/9/2006 20:19'!
on: anObject
	^ self new statement: anObject! !

!JSStatement methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:14'!
statement
	^ statement! !

!JSStatement methodsFor: 'accessing' stamp: 'lr 5/9/2006 20:14'!
statement: anObject
	statement := anObject! !

JSDecoration subclass: #JSTimed
	instanceVariableNames: 'duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

JSTimed subclass: #JSInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSInterval commentStamp: 'lr 10/13/2008 21:46' prior: 0!
I periodically execute the decorated object.!

!JSInterval methodsFor: 'printing' stamp: 'lr 10/13/2008 21:39'!
printContentOn: aStream
	aStream nextPutAll: 'setInterval(function(){'.
	super printContentOn: aStream.
	aStream nextPutAll: '},'; javascript: self duration; nextPut: $)! !

!JSTimed class methodsFor: 'instance-creation' stamp: 'lr 10/13/2008 21:45'!
duration: aDuration
	^ self new duration: aDuration! !

!JSTimed methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:39'!
duration
	^ duration! !

!JSTimed methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:39'!
duration: aDuration
	duration := aDuration! !

JSTimed subclass: #JSTimeout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Decorations'!

!JSTimeout commentStamp: 'lr 4/28/2008 09:54' prior: 0!
I evaluate the decorated object after a timeout.!

!JSTimeout methodsFor: 'printing' stamp: 'lr 4/17/2007 14:29'!
printContentOn: aStream
	aStream nextPutAll: 'setTimeout(function(){'.
	super printContentOn: aStream.
	aStream nextPutAll: '},'; javascript: self duration; nextPut: $)! !

WAObject subclass: #JSJoin
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSJoin commentStamp: 'lr 4/28/2008 09:46' prior: 0!
I join a collection of JavaScript statements with the given string.!

!JSJoin class methodsFor: 'instance-creation' stamp: 'lr 10/16/2008 19:19'!
new
	^ self on: OrderedCollection new! !

!JSJoin class methodsFor: 'instance-creation' stamp: 'lr 10/16/2008 19:19'!
on: aCollection
	^ self basicNew initializeOn: aCollection! !

!JSJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
collection
	^ collection! !

!JSJoin methodsFor: 'initialization' stamp: 'lr 10/16/2008 19:20'!
initializeOn: aCollection
	collection := aCollection! !

!JSJoin methodsFor: 'printing' stamp: 'lr 10/16/2008 19:43'!
printElement: anObject on: aStream
	anObject isVariableBinding
		ifFalse: [ aStream javascript: anObject ]
		ifTrue: [
			aStream nextPut: $"; nextPutAll: anObject key asString.
			anObject key isNil
				ifTrue: [ aStream nextPut: $" ]
				ifFalse: [
					aStream nextPut: $=.
					anObject value isString
						ifTrue: [ aStream nextPutAll: anObject value; nextPut: $" ]
						ifFalse: [ aStream nextPut: $"; nextPut: $+; javascript: anObject value ] ] ]! !

!JSJoin methodsFor: 'printing' stamp: 'lr 10/16/2008 19:41'!
printEmptyOn: aStream
	aStream nextPutAll: '""'! !

!JSJoin methodsFor: 'printing' stamp: 'lr 10/16/2008 19:45'!
printOn: aStream
	self collection isEmpty
		ifTrue: [ ^ self printEmptyOn: aStream ].
	self collection size = 1
		ifTrue: [ ^ self printElement: self collection first on: aStream ].
	aStream nextPut: $[.
	self collection 
		do: [ :each | self printElement: each on: aStream ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '].join("&")'! !

WAObject subclass: #JSObject
	instanceVariableNames: 'decoration canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

JSObject subclass: #JSLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSLogger commentStamp: 'lr 11/28/2006 10:40' prior: 0!
I am a logger class to be used together with FireBug. I have nothing to do with Scriptaculous directly, but I nicely fit in here as everybody should be using FireBug for Script debugging anyway.!

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assert: anObject 
	self 
		call: 'assert'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject equals: anotherObject 
	self 
		call: 'assertEquals'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:11'!
assert: anObject greater: anotherObject 
	self 
		call: 'assertGreater'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:11'!
assert: anObject less: anotherObject 
	self 
		call: 'assertLess'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:12'!
assert: anObject notEquals: anotherObject 
	self 
		call: 'assertNotEquals'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject notGreater: anotherObject 
	self 
		call: 'assertNotGreater'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:13'!
assert: anObject notLess: anotherObject 
	self 
		call: 'assertNotLess'
		with: anObject
		with: anotherObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertFalse: anObject 
	self 
		call: 'assertFalse'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNotNull: anObject 
	self 
		call: 'assertNotNull'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNotUndefined: anObject 
	self 
		call: 'assertNotUndefined'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertNull: anObject 
	self 
		call: 'assertNull'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertTrue: anObject 
	self 
		call: 'assertTrue'
		with: anObject! !

!JSLogger methodsFor: 'assertions' stamp: 'lr 10/14/2008 09:10'!
assertUndefined: anObject 
	self 
		call: 'assertUndefined'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
debug: anObject 
	self 
		call: 'debug'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
error: anObject 
	self 
		call: 'error'
		with: anObject! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
info: anObject 
	self 
		call: 'info'
		with: anObject! !

!JSLogger methodsFor: 'logging' stamp: 'lr 10/14/2008 09:10'!
log: anObject 
	self 
		call: 'log'
		with: anObject! !

!JSLogger methodsFor: 'logging' stamp: 'lr 10/14/2008 09:10'!
log: anObject format: anArray 
	self 
		call: 'log'
		withArguments: (Array with: anObject) , anArray! !

!JSLogger methodsFor: 'printing' stamp: 'lr 11/28/2006 10:13'!
printContentOn: aStream
	aStream nextPutAll: 'console'! !

!JSLogger methodsFor: 'messages' stamp: 'lr 10/14/2008 09:10'!
warn: anObject 
	self 
		call: 'warn'
		with: anObject! !

!JSObject class methodsFor: 'instance-creation' stamp: 'lr 10/13/2008 22:17'!
on: aCanvas
	^ self new setCanvas: aCanvas! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
& anObject 
	"Combine the receiver and anObject with a logical AND."
	
	self addDecoration: (JSBinary new operator: '&&'; statement: anObject)! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:19'!
, anObject
	"Concatenate the receiver with anObject."

	self addDecoration: (JSConcate on: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:42'!
access: aString 
	"Access the member aString."
	
	self addDecoration: (JSAccess named: aString)! !

!JSObject methodsFor: 'adding' stamp: 'lr 11/17/2008 20:15'!
addDecoration: aDecoration
	"Add a new decoration to the receiver."

	aDecoration setOwner: decoration.
	decoration := aDecoration! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:42'!
alias: aString 
	"Uses aString as an alias for the receiver."
	
	self addDecoration: (JSAlias named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:40'!
apply: aCollection 
	"Apply aCollection of arguments."
	
	self addDecoration: (JSApply new arguments: aCollection)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:40'!
assign: anObject 
	"Assign anObject to the receiver."
	
	self addDecoration: (JSAssignment new object: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
assignLocalTo: aString 
	"Assign the receiver to a local variable aString."
	
	self addDecoration: (JSAssignLocal named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
assignTo: aString 
	"Assign the receiver to a global variable aString."
	
	self addDecoration: (JSAssign named: aString)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/14/2008 09:01'!
call: aString
	"Call the method aString."

	self call: aString withArguments: #()! !

!JSObject methodsFor: 'deprecated' stamp: 'lr 10/14/2008 09:05'!
call: aString argument: anObject
	"Call the method aString with anObject as its argument."

	self
		seasideDeprecatedApi: 'JSObject>>call:argument'
		details: 'Use #call:with: instead'.
	self call: aString with: anObject! !

!JSObject methodsFor: 'deprecated' stamp: 'lr 10/14/2008 09:05'!
call: aString arguments: anArray
	"Call the method aString with aCollection as its arguments."

	self 
		seasideDeprecatedApi: 'JSObject>>call:arguments:'
		details: 'Use #call:withArguments: instead'.
	self call: aString withArguments: anArray! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/14/2008 09:02'!
call: aString with: anObject
	"Call the method aString with anObject as its argument."

	self call: aString withArguments: (Array with: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/14/2008 09:03'!
call: aString with: anObject1 with: anObject2
	"Call the method aString with anObject1 and anObject2 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/14/2008 09:06'!
call: aString with: anObject1 with: anObject2 with: anObject3
	"Call the method aString with anObject1 and anObject2 and anObject3 as its arguments."

	self call: aString withArguments: (Array with: anObject1 with: anObject2 with: anObject3)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/14/2008 09:03'!
call: aString withArguments: anArray
	"Call the method aString with anArray as arguments."

	self access: aString; apply: anArray! !

!JSObject methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:14'!
canvas
	"Answer the current rendering canvas."

	^ canvas! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
condition: anObject 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSCondition on: anObject)! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:19'!
confirm: anObject 
	"Show a confirmation with the message anObject before evaluating the receiver."
	
	self condition: (JSStream new
		nextPutAll: 'confirm';
		argument: anObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
create
	"Instantiate the receiver."
	
	self addDecoration: JSCreate new! !

!JSObject methodsFor: 'accessing' stamp: 'lr 10/13/2008 21:14'!
decoration
	"Answer the top-level decoration in the receivers decoration stack."

	^ decoration! !

!JSObject methodsFor: 'initialization' stamp: 'lr 11/11/2008 22:57'!
initialize
	super initialize.
	decoration := self! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
interval: aDuration
	"Execute the receiver every aDuration."

	self addDecoration: (JSInterval duration: aDuration)! !

!JSObject methodsFor: 'testing' stamp: 'lr 12/4/2008 22:30'!
isJavascript
	^ true! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
not
	"Negate the receiver logically."
	
	self addDecoration: JSNegation new! !

!JSObject methodsFor: 'printing' stamp: 'lr 10/13/2008 21:17'!
printContentOn: aStream
	self subclassResponsibility! !

!JSObject methodsFor: 'printing' stamp: 'lr 10/13/2008 21:17'!
printOn: aStream
	self decoration printContentOn: aStream! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:43'!
property: aString 
	"Treat anObject as a condition to the execution of the receiver."
	
	self addDecoration: (JSProperty named: aString)! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:48'!
render: aRenderable
	"Render aRenderable and answer the resulting string."
	
	^ String streamContents: [ :stream | self render: aRenderable on: stream ]! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:46'!
render: aRenderable on: aStream
	"Render aRenderable on aStream."
	
	| document html previous |
	self requestContext rememberLoadScripts: [ 
		document := JSDocument new.
		document stream: aStream; open: nil.
		previous := canvas context document.
		canvas context document: document.
		html := canvas species context: canvas context.
		html render: aRenderable; flush.
		document close: nil.
		canvas context document: previous ]! !

!JSObject methodsFor: 'convenience' stamp: 'lr 10/14/2008 12:22'!
return: anObject 
	"Return anObject after evaluating the receiver."
	
	self , (JSStream new
		nextPutAll: 'return ';
		javascript: anObject)! !

!JSObject methodsFor: 'utilities' stamp: 'lr 10/14/2008 21:48'!
script: aBlock
	"Evaluate aBlock and answer the string of the generated script."
	
	^ String streamContents: [ :stream | self script: aBlock on: stream ]! !

!JSObject methodsFor: 'utilities' stamp: 'lr 12/5/2008 11:21'!
script: aBlock on: aStream
	"Evaluate aBlock and pass in a script object that is subsequently written to aStream."
	
	| script |
	self requestContext rememberLoadScripts: [ 
		script := JSScript on: canvas.
		aBlock value: script.
		script addAll: self requestContext loadScripts ].
	script printOn: aStream! !

!JSObject methodsFor: 'initialization' stamp: 'lr 10/13/2008 21:17'!
setCanvas: aCanvas
	canvas := aCanvas! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:16'!
then: anObject
	"Evaluates anObject if the receiver treated as a boolean evaluates to true."

	self then: anObject else: nil! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:41'!
then: anObject else: anotherObject 
	"Evaluates anObject if the receiver treated as a boolean evaluates to true, otherwise evaluate anotherObject."
	
	self addDecoration: (JSIfThenElse new
		trueStatement: anObject;
		falseStatement: anotherObject)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
timeout: aDuration 
	"Evaluates the receiver after aDuration."
	
	self addDecoration: (JSTimeout duration: aDuration)! !

!JSObject methodsFor: 'decorations' stamp: 'lr 10/13/2008 21:44'!
| anObject 
	"Combine the receiver and anObject with a logical OR."
	
	self addDecoration: (JSBinary new operator: '||'; statement: anObject)! !

JSObject subclass: #JSScript
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSScript commentStamp: 'lr 4/28/2008 09:41' prior: 0!
I represent a sequence of JavaScript statements.!

JSScript subclass: #JSFunction
	instanceVariableNames: 'return arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSFunction commentStamp: 'lr 4/28/2008 09:40' prior: 0!
I represent an anonymous JavaScript function.!

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:57'!
argument
	^ arguments! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:55'!
arguments
	^ arguments! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 1/4/2007 15:55'!
arguments: aCollection
	arguments := aCollection! !

!JSFunction methodsFor: 'converting' stamp: 'lr 5/17/2006 11:27'!
asFunction
	^ self! !

!JSFunction methodsFor: 'converting' stamp: 'lr 1/4/2007 17:22'!
asFunction: aCollection
	self arguments: aCollection! !

!JSFunction methodsFor: 'initialization' stamp: 'lr 1/4/2007 15:59'!
initialize
	super initialize.
	arguments := #()! !

!JSFunction methodsFor: 'printing' stamp: 'lr 2/19/2007 13:45'!
printContentOn: aStream
	aStream nextPutAll: 'function('.
	self arguments
		do: [ :each | aStream nextPutAll: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPutAll: '){'.
	statements isEmpty ifFalse: [
		statements allButLast
			do: [ :each | aStream javascript: each; nextPut: $; ].
		self return
			ifTrue: [ aStream nextPutAll: 'return ' ].
		aStream javascript: statements last ].
	aStream nextPut: $}! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 5/15/2006 11:04'!
return
	^ return ifNil: [ false ]! !

!JSFunction methodsFor: 'accessing' stamp: 'lr 5/15/2006 11:04'!
return: aBoolean
	return := aBoolean! !

!JSScript methodsFor: 'adding' stamp: 'lr 8/29/2006 08:36'!
, anObject
	self add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 10/19/2008 19:10'!
<< anObject
	^ self add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 8/4/2006 08:59'!
add: anObject
	^ statements add: anObject! !

!JSScript methodsFor: 'adding' stamp: 'lr 12/3/2008 19:11'!
addAll: aCollection
	^ statements addAll: aCollection! !

!JSScript methodsFor: 'conveniance' stamp: 'lr 10/13/2008 21:34'!
alert: anObject 
	self add: (JSStream new
		nextPutAll: 'alert';
		argument: anObject;
		yourself)! !

!JSScript methodsFor: 'conveniance' stamp: 'lr 2/19/2007 13:45'!
callback: aBlock
	self goto: (canvas context actionUrl
		withParameter: (canvas callbacks
			registerActionCallback: aBlock))! !

!JSScript methodsFor: 'conveniance' stamp: 'lr 10/13/2008 21:34'!
goto: anUrl 
	self add: (JSStream new
		nextPutAll: 'window.location=';
		javascript: anUrl)! !

!JSScript methodsFor: 'initialization' stamp: 'lr 5/10/2006 19:47'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!JSScript methodsFor: 'conveniance' stamp: 'lr 10/13/2008 21:24'!
logger
	^ self add: (JSLogger on: canvas)! !

!JSScript methodsFor: 'printing' stamp: 'lr 2/19/2007 13:45'!
printContentOn: aStream
	statements
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $; ]! !

!JSScript methodsFor: 'conveniance' stamp: 'lr 6/6/2006 14:25'!
refresh
	self goto: canvas context actionUrl! !

JSObject subclass: #JSStream
	instanceVariableNames: 'stream'
	classVariableNames: 'This JavascriptCharacters Arguments'
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSStream commentStamp: 'lr 4/28/2008 09:44' prior: 0!
I represent a verbatim JavaScript string. I support streaming facilities to efficiently encode JavaScript input.!

!JSStream class methodsFor: 'snippets' stamp: 'lr 10/16/2008 21:49'!
argument: anInteger
	^ (Arguments at: anInteger + 1) copy! !

!JSStream class methodsFor: 'snippets' stamp: 'lr 10/16/2008 21:49'!
argumentAt: anInteger
	^ (Arguments at: anInteger) copy! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 10/13/2008 21:49'!
encodeDictionary: aDictionary to: aStream 
	"Dictionary or hash-maps common structures in JavaScript, try to optimize their serialization."
	
	| first |
	first := true.
	aStream nextPut: ${.
	aDictionary keysAndValuesDo: [ :key :value |
		first
			ifTrue: [ first := false ]
			ifFalse: [ aStream nextPut: $, ].
		self encodeKey: key value: value to: aStream ].
	aStream nextPut: $}! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 10/13/2008 21:49'!
encodeKey: aKey value: aValue to: aStream 
	"Key-value pairs are common structures in JavaScript, try to optimize their serialization."
	
	(aKey isString and: [ aKey isEmpty not and: [ aKey first isLetter and: [ aKey allSatisfy: [ :each | each isAlphaNumeric ] ] ] ]) 
		ifTrue: [ aStream nextPutAll: aKey ]
		ifFalse: [ self encodeString: aKey seasideString to: aStream ].
	aStream nextPut: $:; javascript: aValue! !

!JSStream class methodsFor: 'encoding' stamp: 'lr 12/5/2008 15:38'!
encodeString: aString to: aStream
	"Strings have a complicated encoding in Javascript, try to optimize their serialization."
	
	| char value encoded |
	aStream nextPut: $".
	1 to: aString size do: [ :index |
		char := aString at: index.
		value := char asInteger.
		value < JavascriptCharacters size
			ifFalse: [ aStream nextPut: char ]
			ifTrue: [
				encoded := JavascriptCharacters at: value + 1.
				encoded isString
					ifTrue: [ aStream nextPutAll: encoded ]
					ifFalse: [ aStream nextPut: encoded ] ] ].
	aStream nextPut: $"! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:36'!
initialize
	self initializeEncoding.
	self initializeSnippets! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:34'!
initializeEncoding
	| escapes |
	JavascriptCharacters := Array new: 127.
	0 to: 31 do: [ :each |
		JavascriptCharacters
			at: each + 1
			put: '\x' , ((each printStringBase: 16)
				padded: #left to: 2 with: $0) ].
	32 to: 126 do: [ :each |
		JavascriptCharacters
			at: each + 1
			put: each asCharacter ].
	escapes := #( 0 '\0' 7 '\a' 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index |
		JavascriptCharacters
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]! !

!JSStream class methodsFor: 'initialization' stamp: 'lr 10/14/2008 11:36'!
initializeSnippets
	This := self on: 'this'.
	Arguments := (0 to: 25)
		collect: [ :each | self on: 'arguments[' , each printString , ']' ]! !

!JSStream class methodsFor: 'instance-creation' stamp: 'lr 5/10/2006 20:36'!
on: aString
	^ self new nextPutAll: aString! !

!JSStream class methodsFor: 'snippets' stamp: 'lr 10/14/2008 11:45'!
this
	^ This copy! !

!JSStream methodsFor: 'streaming' stamp: 'lr 8/4/2006 08:37'!
argument: anObject
	self arguments: (Array with: anObject)! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/10/2006 20:32'!
arguments: aCollection
	self stream arguments: aCollection! !

!JSStream methodsFor: 'accessing' stamp: 'lr 5/1/2006 17:06'!
contents
	^ self stream contents! !

!JSStream methodsFor: 'copying' stamp: 'lr 5/10/2006 20:36'!
copy
	^ self class on: self contents! !

!JSStream methodsFor: 'initialization' stamp: 'lr 4/28/2008 10:37'!
initialize
	super initialize.
	stream := String new writeStream! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
javascript: anObject
	self stream javascript: anObject! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
nextPut: aCharacter
	self stream nextPut: aCharacter! !

!JSStream methodsFor: 'streaming' stamp: 'lr 5/1/2006 17:07'!
nextPutAll: aString
	self stream nextPutAll: aString! !

!JSStream methodsFor: 'printing' stamp: 'lr 4/28/2008 10:00'!
printContentOn: aStream
	aStream nextPutAll: self contents! !

!JSStream methodsFor: 'accessing' stamp: 'lr 5/1/2006 17:06'!
stream
	^ stream! !

WAHtmlStreamDocument subclass: #JSDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSDocument commentStamp: 'lr 4/28/2008 09:47' prior: 0!
I represent a document that is sent back when processing an AJAX request. I am an internal class.!

!JSDocument methodsFor: 'public' stamp: 'lr 8/30/2008 16:22'!
close
	| context attributes |
	context := WACurrentRequestContext value.
	(context isNil or: [ context loadScripts isEmpty ]) ifTrue: [ ^ self ].
	attributes := WAHtmlAttributes new.
	attributes 
		at: 'type'
		put: 'text/javascript'.
	self 
		openTag: 'script'
		attributes: attributes.
	stream nextPutAll: '/*<!![CDATA[*/'.
	context loadScripts 
		do: [ :each | stream nextPutAll: each seasideString ]
		separatedBy: [ stream nextPut: $; ].
	stream nextPutAll: '/*]]>*/'.
	self closeTag: 'script'! !

!JSDocument methodsFor: 'public' stamp: 'lr 4/30/2007 20:32'!
close: aHtmlRoot
	self close! !

!JSDocument methodsFor: 'public' stamp: 'lr 4/30/2007 20:32'!
open: aHtmlRoot! !

!WAPackage class methodsFor: '*javascript-core' stamp: 'lr 12/13/2008 13:03'!
javascriptCore
	^ self new
		name: 'Javascript-Core';
		description: 'Javascript integration in Seaside. Provides a basic functionality to generate Javascript from Smalltalk.';
		addDependency: 'Seaside-Canvas';
		addDependency: 'SmaCC';
		yourself! !

!String methodsFor: '*javascript-core' stamp: 'lr 10/14/2008 00:37'!
asFunction: aCollection
	^ (JSStream on: self) asFunction: aCollection! !

!String methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:28'!
javascriptOn: aStream
	JSStream encodeString: self to: aStream! !

!WAUrl methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:06'!
javascriptOn: aStream 
	aStream javascript: self printString! !

!Stream methodsFor: '*javascript-core' stamp: 'lr 5/10/2006 20:31'!
arguments: aCollection
	self nextPut: $(.
	aCollection
		do: [ :each | self javascript: each ]
		separatedBy: [ self nextPut: $, ].
	self nextPut: $)! !

!Stream methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:45'!
javascript: anObject
	anObject javascriptOn: self! !

!DateAndTime methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:05'!
javascriptMonthIndex
	^ self monthIndex - 1! !

!DateAndTime methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:05'!
javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth hour minute second )
		do: [ :each | aStream print: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

!Object methodsFor: '*javascript-core' stamp: 'lr 1/4/2007 17:20'!
asFunction
	^ self asFunction: #()! !

!Object methodsFor: '*javascript-core' stamp: 'lr 10/14/2008 00:37'!
asFunction: aCollection
	^ JSFunction new add: self; arguments: aCollection! !

!Object methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:49'!
asJavascript
	^ String streamContents: [ :stream | self javascriptOn: stream ]! !

!Object methodsFor: '*javascript-core' stamp: 'lr 12/4/2008 22:30'!
isJavascript
	^ false! !

!Object methodsFor: '*javascript-core' stamp: 'lr 4/20/2006 21:10'!
javascriptOn: aStream
	self printOn: aStream! !

!WATagBrush methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:24'!
passenger: anObject
	"Assign a passenger object to the receiver. This is used to keep a mapping between DOM elements and Smalltalk objects. Note, that to we are required to assign a numeric id to the reciever in order to keep the mapping between DOM element and Smalltalk object."

	self id: (canvas callbacks registerPassenger: anObject)! !

!WATagBrush methodsFor: '*javascript-core' stamp: 'lr 9/7/2008 18:09'!
script: anObject
	"Attach a JavaScript object to the receiver. The argument automatically knows the ID of the DOM element it should operate on and will be evaluated when the page complete loading."

	anObject isNil 
		ifTrue: [ ^ self ].
	(anObject respondsTo: #id:)
		ifTrue: [ anObject id: self ensureId ].
	anObject requestContext 
		addLoadScript: anObject! !

WACallback subclass: #JSAjaxCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSAjaxCallback methodsFor: 'accessing' stamp: 'lr 12/6/2008 20:54'!
block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock isNil
		ifFalse: [ aZeroOrOneArgBlock fixCallbackTemps ]! !

!JSAjaxCallback methodsFor: 'evaluation' stamp: 'lr 12/6/2008 20:47'!
evaluateWithArgument: anObject
	block isNil
		ifFalse: [ block valueWithPossibleArgument: anObject ].
	self requestContext
		respond: WAResponse new doNotCache! !

!JSAjaxCallback methodsFor: 'testing' stamp: 'lr 8/8/2007 17:57'!
isEnabled
	^ true! !

!JSAjaxCallback methodsFor: 'accessing' stamp: 'lr 12/6/2008 20:46'!
priority
	^ 8! !

WACallback subclass: #JSPassenger
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Object'!

!JSPassenger methodsFor: 'evaluation' stamp: 'lr 10/21/2008 16:07'!
evaluateWithArgument: anObject
	self shouldNotImplement! !

!JSPassenger methodsFor: 'testing' stamp: 'lr 10/21/2008 16:07'!
isEnabled
	^ false! !

!JSPassenger methodsFor: 'testing' stamp: 'lr 10/21/2008 16:15'!
isPassenger
	^ true! !

!JSPassenger methodsFor: 'accessing' stamp: 'lr 10/21/2008 16:08'!
object
	^ object! !

!JSPassenger methodsFor: 'initialization' stamp: 'lr 10/21/2008 16:09'!
setObject: anObject
	object := anObject! !

!WACallback methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:16'!
isPassenger
	^ false! !

!Dictionary methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:29'!
javascriptOn: aStream
	JSStream encodeDictionary: self to: aStream! !

!UndefinedObject methodsFor: '*javascript-core' stamp: 'lr 4/11/2006 19:44'!
javascriptOn: aStream
	aStream nextPutAll: 'null'! !

!Date methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:04'!
javascriptMonthIndex
	^ self monthIndex - 1! !

!Date methodsFor: '*javascript-core' stamp: 'lr 3/13/2007 09:04'!
javascriptOn: aStream
	aStream nextPutAll: 'new Date('.
	#( year javascriptMonthIndex dayOfMonth )
		do: [ :each | aStream print: (self perform: each) ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $)! !

SmaCCParser subclass: #JSJsonParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Parser'!

!JSJsonParser class methodsFor: 'generated-comments' stamp: 'lr 2/17/2008 18:09'!
parserDefinitionComment

	"%start 			Value Object Array ArrayObject ;

ArrayObject 	: Object { #liftFirstValue: }
				| Array { #liftFirstValue: }
				;
		
Object			: ""{"" PropertyList ""}"" { #liftSecondValue: }
				;
Property		: String "":"" Value { self createProperty: '1' with: '3' }
				;
PropertyList		: { #createPropertyList }
				| PropertyList "","" Property { self addProperty: '3' to: '1' }
				| Property { self addProperty: '1' to: self createPropertyList }
				;

Array			: ""["" ValueList ""]"" { #liftSecondValue: }
				;
Value			: Literal { #liftFirstValue: }
				| Number { #liftFirstValue: }
				| String { #liftFirstValue: }
				| Object { #liftFirstValue: }
				| Array { #liftFirstValue: }
				;
ValueList		: { #createValueList }
				| ValueList "","" Value { self addValue: '3' to: '1' }
				| Value { self addValue: '1' to: self createValueList }
				;
			
Literal			: ""null"" { #createNull }
				| ""true"" { #createTrue }
				| ""false"" { #createFalse }
				;	
Number 		: <number> { self createNumber: '1' value }
				;
String 			: <string> { self createString: ('1' value copyFrom: 2 to: '1' value size - 1) }
				| <name> { self createName: '1' value }
				;"! !

!JSJsonParser class methodsFor: 'generated-accessing' stamp: 'lr 2/17/2008 18:09'!
scannerClass
	^JSJsonScanner! !

!JSJsonParser class methodsFor: 'generated-starting states' stamp: 'lr 2/17/2008 18:09'!
startingStateForArray
	^4! !

!JSJsonParser class methodsFor: 'generated-starting states' stamp: 'lr 2/17/2008 18:09'!
startingStateForArrayObject
	^5! !

!JSJsonParser class methodsFor: 'generated-starting states' stamp: 'lr 2/17/2008 18:09'!
startingStateForObject
	^3! !

!JSJsonParser class methodsFor: 'generated-starting states' stamp: 'lr 2/17/2008 18:09'!
startingStateForValue
	^2! !

!JSJsonParser methodsFor: 'adding' stamp: 'lr 10/13/2008 20:53'!
addProperty: anAssociation to: aDictionary
	"Add the property anAssociation described with key and value to aDictionary. Subclasses might want to refine this implementation."
	
	^ aDictionary 
		add: anAssociation;
		yourself! !

!JSJsonParser methodsFor: 'adding' stamp: 'lr 10/13/2008 20:53'!
addValue: anObject to: aCollection
	"Add anObject to aColleciton. 	Subclasses might want to refine this implementation."

	^ aCollection 
		add: anObject;
		yourself! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 11/14/2008 07:34'!
createName: aString
	"Create a name literal. Subclasses might want to refine this implementation."

	^ aString! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createPropertyList
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:54'!
createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true! !

!JSJsonParser methodsFor: 'creating' stamp: 'lr 10/13/2008 20:55'!
createValueList
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ OrderedCollection new! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForNumber1: nodes 
	^ self createNumber: (nodes at: 1) value! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForProperty1: nodes 
	^ self createProperty: (nodes at: 1) with: (nodes at: 3)! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForPropertyList2: nodes 
	^ self addProperty: (nodes at: 3) to: (nodes at: 1)! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForPropertyList3: nodes 
	^ self addProperty: (nodes at: 1) to: self createPropertyList! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForString1: nodes 
	^ self createString: ((nodes at: 1) value copyFrom: 2
				to: (nodes at: 1) value size - 1)! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForString2: nodes 
	^ self createName: (nodes at: 1) value! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForValueList2: nodes 
	^ self addValue: (nodes at: 3) to: (nodes at: 1)! !

!JSJsonParser methodsFor: 'generated-reduction actions' stamp: 'lr 2/17/2008 18:09'!
reduceActionForValueList3: nodes 
	^ self addValue: (nodes at: 1) to: self createValueList! !

!JSJsonParser methodsFor: 'generated-tables' stamp: 'lr 2/17/2008 18:09'!
reduceTable
	^#(
#(16 1 #reduceActionForString1:)
#(16 1 #reduceActionForString2:)
#(17 3 #reduceActionForProperty1:)
#(18 0 #createValueList)
#(18 3 #reduceActionForValueList2:)
#(18 1 #reduceActionForValueList3:)
#(19 1 #createNull)
#(19 1 #createTrue)
#(19 1 #createFalse)
#(20 1 #reduceActionForNumber1:)
#(21 0 #createPropertyList)
#(21 3 #reduceActionForPropertyList2:)
#(21 1 #reduceActionForPropertyList3:)
#(22 1 #liftFirstValue:)
#(22 1 #liftFirstValue:)
#(23 3 #liftSecondValue:)
#(26 3 #liftSecondValue:)
#(27 1 #liftFirstValue:)
#(27 1 #liftFirstValue:)
#(27 1 #liftFirstValue:)
#(27 1 #liftFirstValue:)
#(27 1 #liftFirstValue:)
#(28 1 #reduceFor:)
)! !

!JSJsonParser methodsFor: 'generated-tables' stamp: 'lr 2/17/2008 18:09'!
transitionTable
	^#(
#(3 25 5 29 8 33 22 37 23 41 26)
#(3 45 1 25 5 49 6 53 7 29 8 57 10 61 11 65 12 69 16 73 19 77 20 81 23 85 26 89 27)
#(3 25 5 93 26)
#(3 29 8 97 23)
#(3 25 5 29 8 101 22 37 23 41 26)
#(3 46 2 46 3 57 10 61 11 105 16 109 17 113 21)
#(3 45 1 18 3 25 5 49 6 53 7 29 8 18 9 57 10 61 11 65 12 69 16 117 18 73 19 77 20 81 23 85 26 121 27)
#(2 0 24)
#(2 62 24)
#(2 58 24)
#(2 38 2 3 9 24)
#(2 34 2 3 9 24)
#(2 30 2 3 9 24)
#(2 10 2 3 4 9 24)
#(2 6 2 3 4 9 24)
#(2 42 2 3 9 24)
#(2 82 2 3 9 24)
#(2 74 2 3 9 24)
#(2 78 2 3 9 24)
#(2 90 2 3 9 24)
#(2 86 2 3 9 24)
#(2 0 24)
#(2 0 24)
#(2 0 24)
#(2 0 24)
#(2 125 4)
#(2 54 2 3)
#(3 129 2 133 3)
#(3 137 3 141 9)
#(2 26 3 9)
#(3 45 1 25 5 49 6 53 7 29 8 57 10 61 11 65 12 69 16 73 19 77 20 81 23 85 26 145 27)
#(2 70 2 3 9 24)
#(3 57 10 61 11 105 16 149 17)
#(3 45 1 25 5 49 6 53 7 29 8 57 10 61 11 65 12 69 16 73 19 77 20 81 23 85 26 153 27)
#(2 66 2 3 9 24)
#(2 14 2 3)
#(2 50 2 3)
#(2 22 3 9)
)! !

!Association methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:30'!
javascriptOn: aStream
	JSStream encodeKey: self key value: self value to: aStream! !

!Collection methodsFor: '*javascript-core' stamp: 'lr 2/19/2007 13:45'!
javascriptOn: aStream
	aStream nextPut: $[.
	self
		do: [ :each | aStream javascript: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $]! !

SmaCCScanner subclass: #JSJsonScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Javascript-Core-Parser'!

!JSJsonScanner class methodsFor: 'generated-initialization' stamp: 'lr 2/17/2008 18:09'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(10 'false' 1 ) #(10 'null' 7 ) #(10 'true' 6 ) ) do: 
				[:each | 
				(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
					put: each last].
	^ keywordMap! !

!JSJsonScanner class methodsFor: 'generated-comments' stamp: 'lr 2/17/2008 18:09'!
scannerDefinitionComment

	"<name>			: [a-zA-Z_] \w* 
				;
<string>			: \"" ((\\.) | ([^\\\""]))* \"" 
				| \' ((\\.) | ([^\\\']))* \'
				;
<number>		: \-? \d+ (\. \d+)? ([eE] [\-\+]? \d+)?
				;

<whitespace>		: \s+
				;
<comment>		: \/\/ [^\r\n]* (\r | \n | \r\n)	?
				;
<scanComment>	: \/ \*
				;"! !

!JSJsonScanner methodsFor: 'generated-tokens' stamp: 'lr 2/17/2008 18:09'!
emptySymbolTokenId
	^24! !

!JSJsonScanner methodsFor: 'generated-tokens' stamp: 'lr 2/17/2008 18:09'!
errorTokenId
	^25! !

!JSJsonScanner methodsFor: 'generated-scanner' stamp: 'lr 2/17/2008 18:09'!
scan1
	
	[self step.
	currentCharacter <= $!! 
		or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]] 
			whileTrue.
	currentCharacter = $" ifTrue: [^ self recordAndReportMatch: #(11 )].
	currentCharacter = $\ 
		ifTrue: 
			[self step.
			currentCharacter <= $ ifTrue: [^ self scan1].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!JSJsonScanner methodsFor: 'generated-scanner' stamp: 'lr 2/17/2008 18:09'!
scan2
	
	[self step.
	currentCharacter <= $& 
		or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]] 
			whileTrue.
	currentCharacter = $' ifTrue: [^ self recordAndReportMatch: #(11 )].
	currentCharacter = $\ 
		ifTrue: 
			[self step.
			currentCharacter <= $ ifTrue: [^ self scan2].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!JSJsonScanner methodsFor: 'generated-scanner' stamp: 'lr 2/17/2008 18:09'!
scan3
	
	[self recordMatch: #(12 ).
	self step.
	currentCharacter between: $0 and: $9] 
			whileTrue.
	(currentCharacter = $E or: [currentCharacter = $e]) ifTrue: [^ self scan4].
	currentCharacter = $. 
		ifTrue: 
			[self step.
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(12 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					(currentCharacter = $E or: [currentCharacter = $e]) ifTrue: [^ self scan4].
					^ self reportLastMatch].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!JSJsonScanner methodsFor: 'generated-scanner' stamp: 'lr 2/17/2008 18:09'!
scan4
	self step.
	(currentCharacter between: $0 and: $9) 
		ifTrue: 
			[
			[self recordMatch: #(12 ).
			self step.
			currentCharacter between: $0 and: $9] 
					whileTrue.
			^ self reportLastMatch].
	(currentCharacter = $+ or: [currentCharacter = $-]) 
		ifTrue: 
			[self step.
			(currentCharacter between: $0 and: $9) 
				ifTrue: 
					[
					[self recordMatch: #(12 ).
					self step.
					currentCharacter between: $0 and: $9] 
							whileTrue.
					^ self reportLastMatch].
			^ self reportLastMatch].
	^ self reportLastMatch! !

!JSJsonScanner methodsFor: 'scanning' stamp: 'lr 2/4/2008 21:50'!
scanComment
	| char |
	[[(char := stream next) isNil
		or: [char == $*]] whileFalse.
	stream atEnd
		ifTrue: [self scannerError].
	stream peekFor: $/] whileFalse.
	^ self comment! !

!JSJsonScanner methodsFor: 'generated-scanner' stamp: 'lr 2/17/2008 18:09'!
scanForToken
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter = $_ or: [currentCharacter between: $a and: $z]]) 
			ifTrue: 
				[
				[self recordMatch: #(10 ).
				self step.
				(currentCharacter between: $0 and: $9) or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter = $_ or: [currentCharacter between: $a and: $z]]]] 
						whileTrue.
				^ self reportLastMatch].
	(currentCharacter between: $0 and: $9) ifTrue: [^ self scan3].
	((currentCharacter between: Character tab and: Character cr) 
		or: [currentCharacter = Character space]) 
			ifTrue: 
				[
				[self recordMatch: #whitespace.
				self step.
				(currentCharacter between: Character tab and: Character cr) 
					or: [currentCharacter = Character space]] 
						whileTrue.
				^ self reportLastMatch].
	currentCharacter = $" ifTrue: [^ self scan1].
	currentCharacter = $' ifTrue: [^ self scan2].
	currentCharacter = $, ifTrue: [^ self recordAndReportMatch: #(3 )].
	currentCharacter = $- 
		ifTrue: 
			[self step.
			(currentCharacter between: $0 and: $9) ifTrue: [^ self scan3].
			^ self reportLastMatch].
	currentCharacter = $/ 
		ifTrue: 
			[self step.
			currentCharacter = $* ifTrue: [^ self recordAndReportMatch: #scanComment].
			currentCharacter = $/ 
				ifTrue: 
					[
					[self recordMatch: #comment.
					self step.
					currentCharacter <= Character tab or: 
							[(currentCharacter between: (Character value: 11) and: Character newPage) 
								or: [currentCharacter >= (Character value: 14)]]] 
							whileTrue.
					currentCharacter = Character lf 
						ifTrue: [^ self recordAndReportMatch: #comment].
					currentCharacter = Character cr 
						ifTrue: 
							[self recordMatch: #comment.
							self step.
							currentCharacter = Character lf 
								ifTrue: [^ self recordAndReportMatch: #comment].
							^ self reportLastMatch].
					^ self reportLastMatch].
			^ self reportLastMatch].
	currentCharacter = $: ifTrue: [^ self recordAndReportMatch: #(4 )].
	currentCharacter = $[ ifTrue: [^ self recordAndReportMatch: #(8 )].
	currentCharacter = $] ifTrue: [^ self recordAndReportMatch: #(9 )].
	currentCharacter = ${ ifTrue: [^ self recordAndReportMatch: #(5 )].
	currentCharacter = $} ifTrue: [^ self recordAndReportMatch: #(2 )].
	^ self reportLastMatch! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:39'!
passengerAt: aString
	^ self passengerAt: aString ifAbsent: [ nil ]! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:18'!
passengerAt: aString ifAbsent: aBlock
	| passenger |
	passenger := self at: aString ifAbsent: [ ^ aBlock value ].
	passenger isPassenger ifFalse: [ ^ aBlock value ].
	^ passenger object! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 12/6/2008 20:54'!
registerAjaxCallback: aBlock 
	^ self storeCallback: (JSAjaxCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: '*javascript-core' stamp: 'lr 10/21/2008 16:13'!
registerPassenger: anObject
	^ self storeCallback: (JSPassenger new setObject: anObject)! !

!WASmallDictionary methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:29'!
javascriptOn: aStream
	JSStream encodeDictionary: self to: aStream! !

!Duration methodsFor: '*javascript-core' stamp: 'lr 10/13/2008 21:56'!
javascriptOn: aStream
	aStream javascript: self asMilliSeconds! !

!Character methodsFor: '*javascript-core' stamp: 'lr 7/12/2006 12:09'!
javascriptOn: aStream
	(String with: self) javascriptOn: aStream! !
JSStream initialize!
